import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import DetailsHeader from '../DetailsHeader';
import DetailsFact from '../DetailsFact';
import DetailsText from '../DetailsText';
import { factsOrder } from '../helpers';
import { jsx } from "@theme-ui/core";
var AbilityDetails = forwardRef(function (_ref, ref) {
  var _ref$data = _ref.data,
      name = _ref$data.name,
      unparsedDescription = _ref$data.description,
      categories = _ref$data.categories,
      facts = _ref$data.facts,
      rest = _objectWithoutProperties(_ref, ["data"]);

  var _ref2 = facts && facts.find(function (_ref3) {
    var type = _ref3.type;
    return type === 'Recharge';
  }) || {},
      rechargeValue = _ref2.value,
      rechargeIcon = _ref2.icon;

  var description = unparsedDescription;

  if (categories) {
    description = description.replace(new RegExp("^(".concat(categories.map(function (category) {
      return "".concat(category, "\\. ");
    }).join('|'), ")"), 'g'), '');
  }

  return jsx("div", _extends({}, rest, {
    ref: ref
  }), jsx(DetailsHeader, _extends({
    sx: {
      mb: '8px'
    }
  }, rechargeValue && {
    flags: [{
      value: rechargeValue,
      icon: rechargeIcon
    }]
  }), name), jsx(DetailsText, {
    lines: [categories && jsx("span", {
      sx: {
        color: 'gw2.details.abilityType'
      }
    }, categories.map(function (category) {
      return "".concat(category, ". ");
    })), description],
    lineComponent: "span"
  }), facts && (facts.length > 1 || facts[0].type !== 'Recharge') && jsx("div", {
    sx: {
      mt: '12px'
    }
  }, facts.filter(function (_ref4, index) {
    var text = _ref4.text,
        type = _ref4.type,
        status = _ref4.status,
        _ref4$prefix = _ref4.prefix;
    _ref4$prefix = _ref4$prefix === void 0 ? {} : _ref4$prefix;
    var prefixStatus = _ref4$prefix.status;
    return type !== 'Recharge' && facts.findIndex(function (_ref5) {
      var otherText = _ref5.text,
          otherType = _ref5.type,
          otherStatus = _ref5.status,
          _ref5$prefix = _ref5.prefix;
      _ref5$prefix = _ref5$prefix === void 0 ? {} : _ref5$prefix;
      var otherPrefixStatus = _ref5$prefix.status;
      return text === otherText && type === otherType && status === otherStatus && prefixStatus === otherPrefixStatus;
    }) === index;
  }).sort(function (_ref6, _ref7) {
    var a = _ref6.type;
    var b = _ref7.type;
    return (factsOrder[a] || 0) - (factsOrder[b] || 0);
  }).map(function (data, index) {
    return jsx(DetailsFact, {
      key: "".concat(data.type, "-").concat(index),
      data: data
    });
  })));
});
AbilityDetails.propTypes = {
  data: PropTypes.object.isRequired
};
AbilityDetails.displayName = 'AbilityDetails';
export default AbilityDetails;
//# sourceMappingURL=AbilityDetails.js.map