import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Effect from '../Effect';
import augmentations from '../data/augmentations.json';
import { jsx } from "@theme-ui/core";
var Augmentation = forwardRef(function (_ref, ref) {
  var name = _ref.name,
      rest = _objectWithoutProperties(_ref, ["name"]);

  return jsx(Effect, _extends({
    type: "Augmentation",
    name: name,
    description: augmentations[name]
  }, rest, {
    ref: ref
  }));
});
Augmentation.propTypes = {
  name: PropTypes.oneOf(Object.keys(augmentations)).isRequired
};
Augmentation.displayName = 'Augmentation';
export default Augmentation;
//# sourceMappingURL=Augmentation.js.map