import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Effect from '../Effect';
import auras from '../data/auras.json';
import { jsx } from "@theme-ui/core";
var Aura = forwardRef(function (_ref, ref) {
  var name = _ref.name,
      rest = _objectWithoutProperties(_ref, ["name"]);

  return jsx(Effect, _extends({
    type: "Aura",
    name: name,
    displayName: "".concat(name, " Aura"),
    description: auras[name]
  }, rest, {
    ref: ref
  }));
});
Aura.propTypes = {
  name: PropTypes.oneOf(Object.keys(auras)).isRequired
};
Aura.displayName = 'Aura';
export default Aura;
//# sourceMappingURL=Aura.js.map