import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Effect from '../Effect';
import commonEffects from '../data/commonEffects.json';
import { jsx } from "@theme-ui/core";
var CommonEffect = forwardRef(function (_ref, ref) {
  var propsName = _ref.name,
      rest = _objectWithoutProperties(_ref, ["name"]);

  var name = propsName === 'Mistlock Singularity' ? 'Rigorous Certainty' : propsName;
  return jsx(Effect, _extends({
    type: "Common",
    name: name,
    description: commonEffects[name]
  }, rest, {
    ref: ref
  }));
});
CommonEffect.propTypes = {
  name: PropTypes.oneOf(Object.keys(commonEffects)).isRequired
};
CommonEffect.displayName = 'CommonEffect';
export default CommonEffect;
//# sourceMappingURL=CommonEffect.js.map