import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Effect from '../Effect';
import conditions from '../data/conditions.json';
import { jsx } from "@theme-ui/core";
var Condition = forwardRef(function (_ref, ref) {
  var name = _ref.name,
      count = _ref.count,
      rest = _objectWithoutProperties(_ref, ["name", "count"]);

  return jsx(Effect, _extends({
    type: "Condition",
    name: name,
    description: conditions[name]
  }, rest, {
    iconProps: _objectSpread({
      applyCount: count
    }, rest.iconProps),
    ref: ref
  }));
});
Condition.propTypes = {
  name: PropTypes.oneOf(Object.keys(conditions)).isRequired,
  count: PropTypes.number
};
Condition.defaultProps = {
  count: null
};
Condition.displayName = 'Condition';
export default Condition;
//# sourceMappingURL=Condition.js.map