import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Effect from '../Effect';
import consumableEffects from '../data/consumableEffects.json';
import { jsx } from "@theme-ui/core";
var ConsumableEffect = forwardRef(function (_ref, ref) {
  var name = _ref.name,
      rest = _objectWithoutProperties(_ref, ["name"]);

  return jsx(Effect, _extends({
    type: "Consumable",
    name: name,
    description: consumableEffects[name]
  }, rest, {
    ref: ref
  }));
});
ConsumableEffect.propTypes = {
  name: PropTypes.oneOf(Object.keys(consumableEffects)).isRequired
};
ConsumableEffect.displayName = 'ConsumableEffect';
export default ConsumableEffect;
//# sourceMappingURL=ConsumableEffect.js.map