import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Effect from '../Effect';
import controlEffects from '../data/controlEffects.json';
import { jsx } from "@theme-ui/core";
var ControlEffect = forwardRef(function (_ref, ref) {
  var name = _ref.name,
      rest = _objectWithoutProperties(_ref, ["name"]);

  return jsx(Effect, _extends({
    type: "Control",
    name: name,
    description: controlEffects[name]
  }, rest, {
    ref: ref
  }));
});
ControlEffect.propTypes = {
  name: PropTypes.oneOf(Object.keys(controlEffects)).isRequired
};
ControlEffect.displayName = 'ControlEffect';
export default ControlEffect;
//# sourceMappingURL=ControlEffect.js.map