import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Icon from '../Icon';
import DetailsHeaderTitle from '../DetailsHeaderTitle';
import { jsx } from "@theme-ui/core";
var DetailsHeader = forwardRef(function (_ref, ref) {
  var icon = _ref.icon,
      iconProps = _ref.iconProps,
      titleProps = _ref.titleProps,
      flags = _ref.flags,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["icon", "iconProps", "titleProps", "flags", "children"]);

  return jsx("div", _extends({
    sx: {
      display: 'flex',
      flexDirection: 'row',
      mb: '3px'
    }
  }, rest, {
    ref: ref
  }), typeof icon === 'string' || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.src) || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.name) ? jsx(Icon, _extends({
    src: icon
  }, iconProps, {
    sx: _objectSpread({
      fontSize: '32px',
      mr: '6px',
      border: '1px solid #cfd0d0',
      borderRadius: '0px'
    }, iconProps.sx)
  })) : icon, jsx(DetailsHeaderTitle, titleProps, children), flags && jsx("div", {
    sx: {
      ml: '6px'
    }
  }, flags.map(function (_ref2) {
    var flagIcon = _ref2.icon,
        value = _ref2.value;
    return jsx("span", {
      key: "".concat(flagIcon, "-").concat(value)
    }, value, flagIcon && jsx(Icon, {
      src: flagIcon,
      sx: {
        ml: '2px'
      }
    }));
  })));
});
DetailsHeader.propTypes = {
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  iconProps: PropTypes.object,
  titleProps: PropTypes.object,
  flags: PropTypes.arrayOf(PropTypes.shape({
    icon: PropTypes.string,
    value: PropTypes.node
  }))
};
DetailsHeader.defaultProps = {
  icon: null,
  iconProps: {},
  titleProps: {},
  flags: []
};
DetailsHeader.displayName = 'DetailsHeader';
export default DetailsHeader;
//# sourceMappingURL=DetailsHeader.js.map