import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Tooltip from '../Tooltip';
import DetailsHeader from '../DetailsHeader';
import DetailsText from '../DetailsText';
import IconWithText from '../IconWithText';
import { jsx } from "@theme-ui/core";
var Error = forwardRef(function (_ref, ref) {
  var component = _ref.component,
      name = _ref.name,
      message = _ref.message,
      code = _ref.code,
      disableTooltip = _ref.disableTooltip,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      inline = _ref.inline,
      tooltipProps = _ref.tooltipProps,
      rest = _objectWithoutProperties(_ref, ["component", "name", "message", "code", "disableTooltip", "disableIcon", "disableText", "inline", "tooltipProps"]);

  return jsx(Tooltip, _extends({
    content: jsx(React.Fragment, null, jsx(DetailsHeader, {
      iconProps: {
        name: code
      },
      titleProps: {
        sx: {
          color: 'error'
        }
      }
    }, name), jsx(DetailsText, {
      lines: [jsx(React.Fragment, null, message, code && " (code ".concat(code, ")"))]
    })),
    disabled: disableTooltip
  }, tooltipProps), jsx(IconWithText, _extends({
    component: component,
    text: name,
    disableIcon: disableIcon,
    disableText: disableText,
    inline: inline
  }, rest, {
    iconProps: _objectSpread({
      name: code
    }, rest.iconProps),
    sx: _objectSpread({
      color: 'error'
    }, rest.sx),
    ref: ref
  })));
});
Error.propTypes = {
  component: PropTypes.elementType,
  code: PropTypes.string,
  name: PropTypes.string,
  message: PropTypes.string,
  disableIcon: PropTypes.bool,
  disableText: PropTypes.bool,
  disableTooltip: PropTypes.bool,
  inline: PropTypes.bool,
  tooltipProps: PropTypes.object
};
Error.defaultProps = {
  component: undefined,
  code: null,
  name: null,
  message: null,
  disableIcon: false,
  disableText: false,
  disableTooltip: false,
  inline: true,
  tooltipProps: {}
};
Error.displayName = 'Error';
export default Error;
//# sourceMappingURL=Error.js.map