import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import PropTypes from 'prop-types';
import React, { forwardRef } from 'react';
import { Spinner } from '..';
import withAsyncProp from '../helpers/withAsyncProp';
import { jsx } from "@theme-ui/core";
var Icon = forwardRef(function (_ref, ref) {
  var Component = _ref.component,
      loading = _ref.loading,
      spinnerProps = _ref.spinnerProps,
      src = _ref.src,
      name = _ref.name,
      zoom = _ref.zoom,
      inline = _ref.inline,
      gutterRight = _ref.gutterRight,
      gutterLeft = _ref.gutterLeft,
      hexagon = _ref.hexagon,
      applyCount = _ref.applyCount,
      inactive = _ref.inactive,
      applyCountProps = _ref.applyCountProps,
      rest = _objectWithoutProperties(_ref, ["component", "loading", "spinnerProps", "src", "name", "zoom", "inline", "gutterRight", "gutterLeft", "hexagon", "applyCount", "inactive", "applyCountProps"]);

  var sharedSx = _objectSpread({}, gutterRight && {
    mr: '0.25em'
  }, {}, gutterLeft && {
    ml: '0.25em'
  }, {}, inline && {
    verticalAlign: 'text-top'
  }, {}, inactive && {
    opacity: 0.5,
    willChange: 'opacity',
    transition: 'opacity 200ms',
    '&:hover': {
      opacity: 0.8
    }
  }, {}, hexagon && {
    width: '0.875em'
  }, {}, rest.sx);

  if (loading) {
    return jsx(Spinner, _extends({
      inline: inline
    }, {
      style: rest.style,
      className: rest.classname
    }, {
      sx: _objectSpread({}, sharedSx)
    }, spinnerProps));
  }

  if (!src) {
    return null;
  }

  return jsx(Component, _extends({}, rest, {
    sx: _objectSpread({
      display: 'inline-flex',
      size: '1em',
      position: 'relative',
      backgroundPosition: 'center',
      backgroundRepeat: 'no-repeat',
      borderRadius: '0px'
    }, src && {
      backgroundImage: "url('".concat(src, "')")
    }, {}, zoom && !hexagon && {
      backgroundSize: "".concat(100 + zoom, "%")
    }, {}, (!zoom || hexagon) && {
      backgroundSize: 'cover'
    }, {}, hexagon && {
      clipPath: 'polygon(50% 4%, 100% 28%, 100% 73%, 50% 99%, 0% 73%, 0% 28%)',
      borderRadius: '0px'
    }, {}, sharedSx),
    ref: ref
  }), applyCount > 1 && jsx("span", _extends({}, applyCountProps, {
    sx: _objectSpread({
      position: 'absolute',
      bottom: '0.2em',
      right: 0,
      fontSize: '0.5em',
      fontWeight: 'gw2.body',
      fontFamily: 'gw2.body',
      lineHeight: 1,
      color: '#fff',
      textShadow: '1px 1px 1px black'
    }, applyCountProps === null || applyCountProps === void 0 ? void 0 : applyCountProps.sx)
  }), applyCount));
});
Icon.propTypes = {
  component: PropTypes.elementType,
  src: PropTypes.string,
  name: PropTypes.string,
  applyCount: PropTypes.number,
  zoom: PropTypes.number,
  inline: PropTypes.bool,
  gutterRight: PropTypes.bool,
  gutterLeft: PropTypes.bool,
  hexagon: PropTypes.bool,
  inactive: PropTypes.bool,
  loading: PropTypes.bool,
  spinnerProps: PropTypes.object,
  applyCountProps: PropTypes.object
};
Icon.defaultProps = {
  component: 'span',
  src: null,
  name: null,
  applyCount: null,
  zoom: null,
  inline: true,
  gutterRight: false,
  gutterLeft: false,
  hexagon: false,
  inactive: false,
  loading: false,
  spinnerProps: {},
  applyCountProps: {}
};
Icon.displayName = 'Icon';
export default withAsyncProp(function (_ref2) {
  var src = _ref2.src,
      name = _ref2.name;
  return !src && name && {
    src: import("../assets/images/icons/".concat("".concat(name).replace('.', '/').replace(/[^\w\\/]/g, ''), ".png")).then(function (_ref3) {
      var module = _ref3["default"];
      return module;
    })
  };
}, ['name'])(Icon);
//# sourceMappingURL=Icon.js.map