import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Icon from '../Icon';
import Progress from '../Progress';
import { jsx } from "@theme-ui/core";
var IconWithText = forwardRef(function (_ref, ref) {
  var Component = _ref.component,
      icon = _ref.icon,
      iconPosition = _ref.iconPosition,
      text = _ref.text,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      inline = _ref.inline,
      iconProps = _ref.iconProps,
      textProps = _ref.textProps,
      progressProps = _ref.progressProps,
      loading = _ref.loading,
      rest = _objectWithoutProperties(_ref, ["component", "icon", "iconPosition", "text", "disableIcon", "disableText", "inline", "iconProps", "textProps", "progressProps", "loading"]);

  return jsx(Component, _extends({
    sx: {
      color: 'text',
      fontFamily: 'gw2.body',
      fontWeight: 'gw2.body',
      lineHeight: 'gw2.body'
    }
  }, rest, {
    ref: ref
  }), !disableIcon && iconPosition === 'left' && (loading || typeof icon === 'string' || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.src) || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.name) ? jsx(Icon, _extends({
    src: icon,
    gutterRight: !disableText,
    inline: !disableText || inline,
    loading: loading
  }, iconProps)) : icon), !disableText && (loading ? jsx(Progress, _extends({
    inline: !disableText || inline
  }, progressProps)) : jsx("span", textProps, text)), !disableIcon && iconPosition === 'right' && (loading || typeof icon === 'string' || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.src) || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.name) ? jsx(Icon, _extends({
    src: icon,
    gutterLeft: !disableText,
    inline: !disableText || inline,
    loading: loading
  }, iconProps)) : icon));
});
IconWithText.propTypes = {
  component: PropTypes.elementType,
  icon: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  iconPosition: PropTypes.oneOf(['left', 'right']),
  text: PropTypes.node,
  disableIcon: PropTypes.bool,
  disableText: PropTypes.bool,
  inline: PropTypes.bool,
  iconProps: PropTypes.object,
  textProps: PropTypes.object,
  progressProps: PropTypes.object,
  loading: PropTypes.bool
};
IconWithText.defaultProps = {
  component: 'span',
  icon: null,
  iconPosition: 'left',
  text: null,
  disableIcon: false,
  disableText: false,
  inline: true,
  iconProps: {},
  textProps: {},
  progressProps: {},
  loading: false
};
IconWithText.displayName = 'IconWithText';
export default IconWithText;
//# sourceMappingURL=IconWithText.js.map