import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Effect from '../Effect';
import mistlockInstabilities from '../data/mistlockInstabilities.json';
import { jsx } from "@theme-ui/core";
var MistlockInstability = forwardRef(function (_ref, ref) {
  var name = _ref.name,
      rest = _objectWithoutProperties(_ref, ["name"]);

  return jsx(Effect, _extends({
    type: "Mistlock Instability",
    name: name,
    displayName: "Mistlock Instability: ".concat(name),
    description: mistlockInstabilities[name]
  }, rest, {
    ref: ref
  }));
});
MistlockInstability.propTypes = {
  name: PropTypes.oneOf(Object.keys(mistlockInstabilities)).isRequired
};
MistlockInstability.displayName = 'MistlockInstability';
export default MistlockInstability;
//# sourceMappingURL=MistlockInstability.js.map