import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import { keyframes } from '@emotion/core';
import { jsx } from "@theme-ui/core";
var progress = keyframes({
  from: {
    backgroundPosition: '-4em 0'
  },
  to: {
    backgroundPosition: '4em 0'
  }
});
var Progress = forwardRef(function (_ref, ref) {
  var Component = _ref.component,
      inline = _ref.inline,
      rest = _objectWithoutProperties(_ref, ["component", "inline"]);

  return jsx(Component, _extends({
    sx: _objectSpread({
      display: 'inline-flex',
      alignItems: 'flex-end',
      width: '4em',
      height: '1em'
    }, inline && {
      verticalAlign: 'text-top'
    }, {
      ':before': {
        content: '""',
        width: '100%',
        height: '85%',
        backgroundColor: "rgba(0,0,0,0.2)",
        backgroundImage: 'linear-gradient(90deg, rgba(0,0,0,0), rgba(0,0,0,0.2), currentColor, rgba(0,0,0,0.2), rgba(0,0,0,0))',
        backgroundRepeat: 'no-repeat',
        animation: "".concat(progress, " 1.5s infinite"),
        borderRadius: '4px'
      }
    })
  }, rest, {
    ref: ref
  }));
});
Progress.propTypes = {
  component: PropTypes.elementType,
  inline: PropTypes.bool
};
Progress.defaultProps = {
  component: 'span',
  inline: true
};
Progress.displayName = 'Progress';
export default Progress;
//# sourceMappingURL=Progress.js.map