import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import { keyframes } from '@emotion/core';
import { jsx } from "@theme-ui/core";
var spin = keyframes({
  from: {
    transform: 'rotate(0deg)'
  },
  to: {
    transform: 'rotate(360deg)'
  }
});
var Spinner = forwardRef(function (_ref, ref) {
  var Component = _ref.component,
      inline = _ref.inline,
      rest = _objectWithoutProperties(_ref, ["component", "inline"]);

  return jsx(Component, _extends({
    sx: _objectSpread({
      display: 'inline-flex',
      size: "1em",
      border: "4px rgba(0,0,0,0.2) solid",
      borderTopColor: "currentColor",
      borderRadius: '50%',
      animation: "".concat(spin.toString(), " .8s linear infinite"),
      boxSizing: 'border-box'
    }, inline && {
      verticalAlign: 'text-top'
    })
  }, rest, {
    ref: ref
  }));
});
Spinner.propTypes = {
  component: PropTypes.elementType,
  inline: PropTypes.bool
};
Spinner.defaultProps = {
  component: 'span',
  inline: true
};
Spinner.displayName = 'Spinner';
export default Spinner;
//# sourceMappingURL=Spinner.js.map