import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef, useState } from 'react';
import PropTypes from 'prop-types';
import Tippy from '@tippyjs/react/headless';
import { followCursor } from 'tippy.js/headless';
import TooltipContainer from '../TooltipContainer';
import { jsx } from "@theme-ui/core";
var Tooltip = forwardRef(function (_ref, ref) {
  var propsContent = _ref.content,
      _render = _ref.render,
      containerProps = _ref.containerProps,
      wrapperProps = _ref.wrapperProps,
      rest = _objectWithoutProperties(_ref, ["content", "render", "containerProps", "wrapperProps"]);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      mounted = _useState2[0],
      setMounted = _useState2[1];

  var lazyPlugin = {
    fn: function fn() {
      return {
        onShow: function onShow() {
          return setMounted(true);
        },
        onHidden: function onHidden() {
          return setMounted(false);
        }
      };
    }
  };
  return jsx(Tippy, _extends({
    ignoreAttributes: true,
    followCursor: true,
    plugins: [lazyPlugin, followCursor],
    render: function render(attrs) {
      if (!mounted) {
        return null;
      }

      var content = null;

      if (propsContent) {
        content = jsx(TooltipContainer, containerProps, propsContent);
      } else if (typeof _render === 'function') {
        content = _render();
      } else if (_render != null) {
        content = _render;
      }

      return jsx("div", _extends({
        sx: {
          maxHeight: 'calc(100vh - 20px)',
          display: 'flex',
          flexDirection: 'column',
          flexWrap: 'wrap',
          zIndex: 'tooltip'
        },
        tabIndex: "-1"
      }, wrapperProps, attrs), content);
    }
  }, rest, {
    ref: ref
  }));
});
Tooltip.propTypes = {
  content: PropTypes.node,
  render: PropTypes.oneOfType([PropTypes.func, PropTypes.node]),
  containerProps: PropTypes.object,
  wrapperProps: PropTypes.object
};
Tooltip.defaultProps = {
  content: null,
  render: null,
  containerProps: {},
  wrapperProps: {}
};
Tooltip.displayName = 'Tooltip';
export default Tooltip;
//# sourceMappingURL=Tooltip.js.map