import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import { useColorModeHighlightSuffix } from '../helpers';
import { jsx } from "@theme-ui/core";
export var languages = ['en', 'zh', 'cs', 'nl', 'fi', 'fr', 'de', 'hu', 'it', 'ja', 'ko', 'ms', 'po', 'pt', 'ru', 'es', 'sv', 'tr', 'un'];
var WikiLink = forwardRef(function (_ref, ref) {
  var Component = _ref.component,
      to = _ref.to,
      lang = _ref.lang,
      rest = _objectWithoutProperties(_ref, ["component", "to", "lang"]);

  var highlightSuffix = useColorModeHighlightSuffix();
  return jsx(Component, _extends({
    sx: {
      color: 'primary',
      textDecoration: 'none',
      transition: 'color 200ms ease-in-out',
      '&:hover': {
        color: "primary".concat(highlightSuffix)
      }
    },
    href: "https://wiki-".concat(lang, ".guildwars2.com/wiki/Special:Search/").concat(encodeURIComponent(to)),
    target: "_blank",
    rel: "noreferrer noopener nofollow"
  }, rest, {
    ref: ref
  }), to);
});
WikiLink.propTypes = {
  component: PropTypes.elementType,
  to: PropTypes.string.isRequired,
  lang: PropTypes.oneOf(languages)
};
WikiLink.defaultProps = {
  component: 'a',
  lang: 'en'
};
WikiLink.displayName = 'WikiLink';
export default WikiLink;
//# sourceMappingURL=WikiLink.js.map