var progression = [{
  min: 2,
  max: 10,
  increase: 7
}, {
  min: 11,
  max: 20,
  increase: 10
}, {
  min: 21,
  max: 24,
  increase: 14
}, {
  min: 25,
  max: 26,
  increase: 15
}, {
  min: 27,
  max: 30,
  increase: 16
}, {
  min: 31,
  max: 40,
  increase: 20
}, {
  min: 41,
  max: 44,
  increase: 24
}, {
  min: 45,
  max: 46,
  increase: 25
}, {
  min: 47,
  max: 50,
  increase: 26
}, {
  min: 51,
  max: 60,
  increase: 30
}, {
  min: 61,
  max: 64,
  increase: 34
}, {
  min: 65,
  max: 66,
  increase: 35
}, {
  min: 67,
  max: 70,
  increase: 36
}, {
  min: 71,
  max: 74,
  increase: 44
}, {
  min: 75,
  max: 76,
  increase: 45
}, {
  min: 77,
  max: 80,
  increase: 46
}];
var primaryAttributes = ['Power', 'Precision', 'Toughness', 'Vitality'];
export default (function (level) {
  if (!level) {
    return {};
  }

  var primaryAttributesBaseValue = 37;

  if (level >= 2) {
    var _loop = function _loop(i) {
      var _progression$find2 = progression.find(function (_ref2) {
        var min = _ref2.min,
            max = _ref2.max;
        return min <= i && max >= i;
      }),
          increase = _progression$find2.increase;

      primaryAttributesBaseValue += increase;
    };

    for (var i = 2; i <= Math.min(10, level); i += 1) {
      _loop(i);
    }

    if (level >= 10) {
      var _loop2 = function _loop2(_i) {
        var _progression$find = progression.find(function (_ref) {
          var min = _ref.min,
              max = _ref.max;
          return min <= _i && max >= _i;
        }),
            increase = _progression$find.increase;

        primaryAttributesBaseValue += increase;
      };

      for (var _i = 12; _i <= Math.min(80, level); _i += 2) {
        _loop2(_i);
      }
    }
  }

  return primaryAttributes.reduce(function (result, primaryAttribute) {
    result[primaryAttribute] = primaryAttributesBaseValue;
    return result;
  }, {});
});
//# sourceMappingURL=getBaseAttributes.js.map