import _typeof from "@babel/runtime/helpers/typeof";
import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React, { Component as ReactComponent, forwardRef } from 'react';
import { getDisplayName } from '.';
import { jsx } from "@theme-ui/core";
export default (function (transformProps, keys) {
  return function (Component) {
    var WithAsyncProp = function (_ReactComponent) {
      _inherits(WithAsyncProp, _ReactComponent);

      var _super = _createSuper(WithAsyncProp);

      function WithAsyncProp() {
        var _this;

        _classCallCheck(this, WithAsyncProp);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _super.call.apply(_super, [this].concat(args));

        _defineProperty(_assertThisInitialized(_this), "state", {});

        _defineProperty(_assertThisInitialized(_this), "componentDidMount", _asyncToGenerator(_regeneratorRuntime.mark(function _callee() {
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  return _context.abrupt("return", _this.resolveProps());

                case 1:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        })));

        _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function () {
          var _ref2 = _asyncToGenerator(_regeneratorRuntime.mark(function _callee2(previousProps) {
            return _regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    if (!((!keys || !keys.length) && previousProps !== _this.props || keys.some(function (key) {
                      return previousProps[key] !== _this.props[key];
                    }))) {
                      _context2.next = 3;
                      break;
                    }

                    _context2.next = 3;
                    return _this.resolveProps();

                  case 3:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }));

          return function (_x) {
            return _ref2.apply(this, arguments);
          };
        }());

        _defineProperty(_assertThisInitialized(_this), "shouldComponentUpdate", function (nextProps, nextState) {
          if (nextState !== _this.state) {
            return true;
          }

          var _this$props = _this.props,
              transformed = _this$props[keys],
              rest = _objectWithoutProperties(_this$props, [keys].map(_toPropertyKey));

          var nextTransformed = nextProps[keys],
              nextRest = _objectWithoutProperties(nextProps, [keys].map(_toPropertyKey));

          return _objectSpread({}, rest) !== _objectSpread({}, nextRest);
        });

        _defineProperty(_assertThisInitialized(_this), "resolveProps", _asyncToGenerator(_regeneratorRuntime.mark(function _callee4() {
          return _regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  return _context4.abrupt("return", Promise.all(Object.entries(transformProps(_this.props) || {}).filter(function (_ref4) {
                    var _ref5 = _slicedToArray(_ref4, 2),
                        transform = _ref5[1];

                    return !!transform;
                  }).map(function () {
                    var _ref7 = _asyncToGenerator(_regeneratorRuntime.mark(function _callee3(_ref6) {
                      var _ref8, key, transform, value;

                      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                        while (1) {
                          switch (_context3.prev = _context3.next) {
                            case 0:
                              _ref8 = _slicedToArray(_ref6, 2), key = _ref8[0], transform = _ref8[1];
                              _context3.prev = 1;
                              _context3.next = 4;
                              return transform;

                            case 4:
                              value = _context3.sent;

                              _this.setState(_defineProperty({}, key, value));

                              _context3.next = 11;
                              break;

                            case 8:
                              _context3.prev = 8;
                              _context3.t0 = _context3["catch"](1);

                              _this.setState(_defineProperty({}, key, null));

                            case 11:
                            case "end":
                              return _context3.stop();
                          }
                        }
                      }, _callee3, null, [[1, 8]]);
                    }));

                    return function (_x2) {
                      return _ref7.apply(this, arguments);
                    };
                  }())));

                case 1:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        })));

        _defineProperty(_assertThisInitialized(_this), "render", function () {
          var _this$props2 = _this.props,
              forwardedRef = _this$props2.forwardedRef,
              rest = _objectWithoutProperties(_this$props2, ["forwardedRef"]);

          return jsx(Component, _extends({
            ref: forwardedRef
          }, rest, _this.state));
        });

        return _this;
      }

      return WithAsyncProp;
    }(ReactComponent);

    var forwardRefFn = function forwardRefFn(props, ref) {
      return jsx(WithAsyncProp, _extends({}, props, {
        forwardedRef: ref
      }));
    };

    forwardRefFn.displayName = "WithAsyncProp(".concat(getDisplayName(Component), ")");
    return forwardRef(forwardRefFn);
  };
});
//# sourceMappingURL=withAsyncProp.js.map