"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DetailsHeader = _interopRequireDefault(require("../DetailsHeader"));

var _DetailsFact = _interopRequireDefault(require("../DetailsFact"));

var _DetailsText = _interopRequireDefault(require("../DetailsText"));

var _helpers = require("../helpers");

var _core = require("@theme-ui/core");

var AbilityDetails = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$data = _ref.data,
      name = _ref$data.name,
      unparsedDescription = _ref$data.description,
      categories = _ref$data.categories,
      facts = _ref$data.facts,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["data"]);

  var _ref2 = facts && facts.find(function (_ref3) {
    var type = _ref3.type;
    return type === 'Recharge';
  }) || {},
      rechargeValue = _ref2.value,
      rechargeIcon = _ref2.icon;

  var description = unparsedDescription;

  if (categories) {
    description = description.replace(new RegExp("^(".concat(categories.map(function (category) {
      return "".concat(category, "\\. ");
    }).join('|'), ")"), 'g'), '');
  }

  return (0, _core.jsx)("div", (0, _extends2["default"])({}, rest, {
    ref: ref
  }), (0, _core.jsx)(_DetailsHeader["default"], (0, _extends2["default"])({
    sx: {
      mb: '8px'
    }
  }, rechargeValue && {
    flags: [{
      value: rechargeValue,
      icon: rechargeIcon
    }]
  }), name), (0, _core.jsx)(_DetailsText["default"], {
    lines: [categories && (0, _core.jsx)("span", {
      sx: {
        color: 'gw2.details.abilityType'
      }
    }, categories.map(function (category) {
      return "".concat(category, ". ");
    })), description],
    lineComponent: "span"
  }), facts && (facts.length > 1 || facts[0].type !== 'Recharge') && (0, _core.jsx)("div", {
    sx: {
      mt: '12px'
    }
  }, facts.filter(function (_ref4, index) {
    var text = _ref4.text,
        type = _ref4.type,
        status = _ref4.status,
        _ref4$prefix = _ref4.prefix;
    _ref4$prefix = _ref4$prefix === void 0 ? {} : _ref4$prefix;
    var prefixStatus = _ref4$prefix.status;
    return type !== 'Recharge' && facts.findIndex(function (_ref5) {
      var otherText = _ref5.text,
          otherType = _ref5.type,
          otherStatus = _ref5.status,
          _ref5$prefix = _ref5.prefix;
      _ref5$prefix = _ref5$prefix === void 0 ? {} : _ref5$prefix;
      var otherPrefixStatus = _ref5$prefix.status;
      return text === otherText && type === otherType && status === otherStatus && prefixStatus === otherPrefixStatus;
    }) === index;
  }).sort(function (_ref6, _ref7) {
    var a = _ref6.type;
    var b = _ref7.type;
    return (_helpers.factsOrder[a] || 0) - (_helpers.factsOrder[b] || 0);
  }).map(function (data, index) {
    return (0, _core.jsx)(_DetailsFact["default"], {
      key: "".concat(data.type, "-").concat(index),
      data: data
    });
  })));
});
AbilityDetails.propTypes = {
  data: _propTypes["default"].object.isRequired
};
AbilityDetails.displayName = 'AbilityDetails';
var _default = AbilityDetails;
exports["default"] = _default;
//# sourceMappingURL=AbilityDetails.js.map