"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _DetailsHeaderTitle = _interopRequireDefault(require("../DetailsHeaderTitle"));

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var DetailsHeader = (0, _react.forwardRef)(function (_ref, ref) {
  var icon = _ref.icon,
      iconProps = _ref.iconProps,
      titleProps = _ref.titleProps,
      flags = _ref.flags,
      children = _ref.children,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["icon", "iconProps", "titleProps", "flags", "children"]);
  return (0, _core.jsx)("div", (0, _extends2["default"])({
    sx: {
      display: 'flex',
      flexDirection: 'row',
      mb: '3px'
    }
  }, rest, {
    ref: ref
  }), typeof icon === 'string' || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.src) || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.name) ? (0, _core.jsx)(_Icon["default"], (0, _extends2["default"])({
    src: icon
  }, iconProps, {
    sx: _objectSpread({
      fontSize: '32px',
      mr: '6px',
      border: '1px solid #cfd0d0',
      borderRadius: '0px'
    }, iconProps.sx)
  })) : icon, (0, _core.jsx)(_DetailsHeaderTitle["default"], titleProps, children), flags && (0, _core.jsx)("div", {
    sx: {
      ml: '6px'
    }
  }, flags.map(function (_ref2) {
    var flagIcon = _ref2.icon,
        value = _ref2.value;
    return (0, _core.jsx)("span", {
      key: "".concat(flagIcon, "-").concat(value)
    }, value, flagIcon && (0, _core.jsx)(_Icon["default"], {
      src: flagIcon,
      sx: {
        ml: '2px'
      }
    }));
  })));
});
DetailsHeader.propTypes = {
  icon: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  iconProps: _propTypes["default"].object,
  titleProps: _propTypes["default"].object,
  flags: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    icon: _propTypes["default"].string,
    value: _propTypes["default"].node
  }))
};
DetailsHeader.defaultProps = {
  icon: null,
  iconProps: {},
  titleProps: {},
  flags: []
};
DetailsHeader.displayName = 'DetailsHeader';
var _default = DetailsHeader;
exports["default"] = _default;
//# sourceMappingURL=DetailsHeader.js.map