"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@theme-ui/core");

var REGEX = new RegExp('<c=@([^>]+?>[^<>]+?)(?:</c>|$)', 'g');

var renderFlavor = function renderFlavor(text) {
  var parts = text.replace(/<br\s*?\/?\s*?>/g, '\n').split(REGEX);

  for (var i = 1; i < parts.length; i += 2) {
    var _parts$i$split = parts[i].split('>'),
        _parts$i$split2 = (0, _slicedToArray2["default"])(_parts$i$split, 2),
        type = _parts$i$split2[0],
        textPart = _parts$i$split2[1];

    if (type) {
      var color = void 0;

      switch (type) {
        case 'ability':
          color = null;
          break;

        case 'abilitytype':
          color = 'abilityType';
          break;

        case 'reminder':
          color = 'muted';
          break;

        default:
          color = type;
          break;
      }

      parts[i] = [textPart, color];
    } else {
      parts[i] = textPart;
    }
  }

  return (0, _core.jsx)(_react["default"].Fragment, null, parts.filter(function (part) {
    return !!part;
  }).map(function (part, index) {
    if (Array.isArray(part)) {
      var _part = (0, _slicedToArray2["default"])(part, 2),
          _textPart = _part[0],
          _color = _part[1];

      if (_color) {
        return (0, _core.jsx)("span", {
          key: index,
          sx: {
            color: "gw2.details.".concat(_color)
          }
        }, _textPart);
      }

      return _textPart;
    }

    return part;
  }));
};

var DetailsText = (0, _react.forwardRef)(function (_ref, ref) {
  var Component = _ref.component,
      LineComponent = _ref.lineComponent,
      lineProps = _ref.lineProps,
      lines = _ref.lines,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["component", "lineComponent", "lineProps", "lines"]);
  return (0, _core.jsx)(Component, (0, _extends2["default"])({}, rest, {
    ref: ref
  }), lines.filter(function (line) {
    return !!line;
  }).map(function (line, index) {
    return (0, _core.jsx)(LineComponent, (0, _extends2["default"])({
      key: index
    }, lineProps), _react["default"].isValidElement(line) ? line : renderFlavor(line));
  }));
});
DetailsText.propTypes = {
  component: _propTypes["default"].elementType,
  lines: _propTypes["default"].arrayOf(_propTypes["default"].node).isRequired,
  lineComponent: _propTypes["default"].elementType,
  lineProps: _propTypes["default"].object
};
DetailsText.defaultProps = {
  component: 'div',
  lineComponent: 'div',
  lineProps: {}
};
DetailsText.displayName = 'DetailsText';
var _default = DetailsText;
exports["default"] = _default;
//# sourceMappingURL=DetailsText.js.map