"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.camelcase"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _DetailsHeader = _interopRequireDefault(require("../DetailsHeader"));

var _DetailsText = _interopRequireDefault(require("../DetailsText"));

var _IconWithText = _interopRequireDefault(require("../IconWithText"));

var _WikiLink = _interopRequireDefault(require("../WikiLink"));

var _Error = _interopRequireDefault(require("../Error"));

var _helpers = require("../helpers");

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Effect = (0, _react.forwardRef)(function (_ref, ref) {
  var type = _ref.type,
      name = _ref.name,
      displayName = _ref.displayName,
      description = _ref.description,
      component = _ref.component,
      disableTooltip = _ref.disableTooltip,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      disableLink = _ref.disableLink,
      inline = _ref.inline,
      wikiLinkProps = _ref.wikiLinkProps,
      tooltipProps = _ref.tooltipProps,
      errorProps = _ref.errorProps,
      className = _ref.className,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["type", "name", "displayName", "description", "component", "disableTooltip", "disableIcon", "disableText", "disableLink", "inline", "wikiLinkProps", "tooltipProps", "errorProps", "className"]);
  var highlightSuffix = (0, _helpers.useColorModeHighlightSuffix)();

  if (!type || !name || typeof description === 'undefined') {
    return (0, _core.jsx)(_Error["default"], (0, _extends2["default"])({
      name: "Invalid ".concat(type || 'Effect').concat(name ? " ".concat(name) : ''),
      message: "Error: No data for ".concat(type || 'Effect').concat(name ? " ".concat(name) : ''),
      disableTooltip: disableTooltip,
      disableIcon: disableIcon,
      disableText: disableText,
      inline: inline,
      iconProps: {
        name: '404'
      },
      className: className
    }, errorProps, {
      style: _objectSpread({}, errorProps === null || errorProps === void 0 ? void 0 : errorProps.style, {}, rest.style),
      sx: _objectSpread({}, errorProps === null || errorProps === void 0 ? void 0 : errorProps.sx, {}, rest.sx)
    }));
  }

  return (0, _core.jsx)(_Tooltip["default"], (0, _extends2["default"])({
    content: (0, _core.jsx)(_react["default"].Fragment, null, (0, _core.jsx)(_DetailsHeader["default"], null, displayName || name), description && (0, _core.jsx)(_DetailsText["default"], {
      lines: [description]
    })),
    disabled: disableTooltip
  }, tooltipProps), (0, _core.jsx)(_IconWithText["default"], (0, _extends2["default"])({
    component: component,
    text: disableLink ? displayName || name : (0, _core.jsx)(_WikiLink["default"], (0, _extends2["default"])({
      to: displayName || name
    }, wikiLinkProps, {
      sx: _objectSpread({
        color: 'inherit',
        '&:hover': {
          color: "gw2.effect.".concat((0, _lodash["default"])(type)).concat(highlightSuffix)
        }
      }, wikiLinkProps === null || wikiLinkProps === void 0 ? void 0 : wikiLinkProps.sx)
    })),
    disableIcon: disableIcon,
    disableText: disableText,
    inline: inline,
    className: className
  }, rest, {
    iconProps: _objectSpread({
      name: "".concat(type, ".").concat(name)
    }, rest.iconProps),
    sx: _objectSpread({
      color: "gw2.effect.".concat((0, _lodash["default"])(type))
    }, rest.sx),
    ref: ref
  })));
});
Effect.propTypes = {
  type: _propTypes["default"].string.isRequired,
  name: _propTypes["default"].string.isRequired,
  displayName: _propTypes["default"].string,
  description: _propTypes["default"].string,
  component: _propTypes["default"].elementType,
  disableTooltip: _propTypes["default"].bool,
  disableIcon: _propTypes["default"].bool,
  disableText: _propTypes["default"].bool,
  disableLink: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  tooltipProps: _propTypes["default"].object,
  wikiLinkProps: _propTypes["default"].object,
  errorProps: _propTypes["default"].object
};
Effect.defaultProps = {
  displayName: null,
  description: undefined,
  component: undefined,
  disableTooltip: false,
  disableIcon: false,
  disableText: false,
  disableLink: false,
  inline: true,
  tooltipProps: {},
  wikiLinkProps: {},
  errorProps: {}
};
Effect.displayName = 'Effect';
var _default = Effect;
exports["default"] = _default;
//# sourceMappingURL=Effect.js.map