"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _DetailsHeader = _interopRequireDefault(require("../DetailsHeader"));

var _DetailsText = _interopRequireDefault(require("../DetailsText"));

var _IconWithText = _interopRequireDefault(require("../IconWithText"));

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Error = (0, _react.forwardRef)(function (_ref, ref) {
  var component = _ref.component,
      name = _ref.name,
      message = _ref.message,
      code = _ref.code,
      disableTooltip = _ref.disableTooltip,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      inline = _ref.inline,
      tooltipProps = _ref.tooltipProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["component", "name", "message", "code", "disableTooltip", "disableIcon", "disableText", "inline", "tooltipProps"]);
  return (0, _core.jsx)(_Tooltip["default"], (0, _extends2["default"])({
    content: (0, _core.jsx)(_react["default"].Fragment, null, (0, _core.jsx)(_DetailsHeader["default"], {
      iconProps: {
        name: code
      },
      titleProps: {
        sx: {
          color: 'error'
        }
      }
    }, name), (0, _core.jsx)(_DetailsText["default"], {
      lines: [(0, _core.jsx)(_react["default"].Fragment, null, message, code && " (code ".concat(code, ")"))]
    })),
    disabled: disableTooltip
  }, tooltipProps), (0, _core.jsx)(_IconWithText["default"], (0, _extends2["default"])({
    component: component,
    text: name,
    disableIcon: disableIcon,
    disableText: disableText,
    inline: inline
  }, rest, {
    iconProps: _objectSpread({
      name: code
    }, rest.iconProps),
    sx: _objectSpread({
      color: 'error'
    }, rest.sx),
    ref: ref
  })));
});
Error.propTypes = {
  component: _propTypes["default"].elementType,
  code: _propTypes["default"].string,
  name: _propTypes["default"].string,
  message: _propTypes["default"].string,
  disableIcon: _propTypes["default"].bool,
  disableText: _propTypes["default"].bool,
  disableTooltip: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  tooltipProps: _propTypes["default"].object
};
Error.defaultProps = {
  component: undefined,
  code: null,
  name: null,
  message: null,
  disableIcon: false,
  disableText: false,
  disableTooltip: false,
  inline: true,
  tooltipProps: {}
};
Error.displayName = 'Error';
var _default = Error;
exports["default"] = _default;
//# sourceMappingURL=Error.js.map