"use strict";

var _interopRequireWildcard3 = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _interopRequireWildcard2 = _interopRequireDefault(require("@babel/runtime/helpers/interopRequireWildcard"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard3(require("react"));

var _ = require("..");

var _withAsyncProp = _interopRequireDefault(require("../helpers/withAsyncProp"));

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Icon = (0, _react.forwardRef)(function (_ref, ref) {
  var Component = _ref.component,
      loading = _ref.loading,
      spinnerProps = _ref.spinnerProps,
      src = _ref.src,
      name = _ref.name,
      zoom = _ref.zoom,
      inline = _ref.inline,
      gutterRight = _ref.gutterRight,
      gutterLeft = _ref.gutterLeft,
      hexagon = _ref.hexagon,
      applyCount = _ref.applyCount,
      inactive = _ref.inactive,
      applyCountProps = _ref.applyCountProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["component", "loading", "spinnerProps", "src", "name", "zoom", "inline", "gutterRight", "gutterLeft", "hexagon", "applyCount", "inactive", "applyCountProps"]);

  var sharedSx = _objectSpread({}, gutterRight && {
    mr: '0.25em'
  }, {}, gutterLeft && {
    ml: '0.25em'
  }, {}, inline && {
    verticalAlign: 'text-top'
  }, {}, inactive && {
    opacity: 0.5,
    willChange: 'opacity',
    transition: 'opacity 200ms',
    '&:hover': {
      opacity: 0.8
    }
  }, {}, hexagon && {
    width: '0.875em'
  }, {}, rest.sx);

  if (loading) {
    return (0, _core.jsx)(_.Spinner, (0, _extends2["default"])({
      inline: inline
    }, {
      style: rest.style,
      className: rest.classname
    }, {
      sx: _objectSpread({}, sharedSx)
    }, spinnerProps));
  }

  if (!src) {
    return null;
  }

  return (0, _core.jsx)(Component, (0, _extends2["default"])({}, rest, {
    sx: _objectSpread({
      display: 'inline-flex',
      size: '1em',
      position: 'relative',
      backgroundPosition: 'center',
      backgroundRepeat: 'no-repeat',
      borderRadius: '0px'
    }, src && {
      backgroundImage: "url('".concat(src, "')")
    }, {}, zoom && !hexagon && {
      backgroundSize: "".concat(100 + zoom, "%")
    }, {}, (!zoom || hexagon) && {
      backgroundSize: 'cover'
    }, {}, hexagon && {
      clipPath: 'polygon(50% 4%, 100% 28%, 100% 73%, 50% 99%, 0% 73%, 0% 28%)',
      borderRadius: '0px'
    }, {}, sharedSx),
    ref: ref
  }), applyCount > 1 && (0, _core.jsx)("span", (0, _extends2["default"])({}, applyCountProps, {
    sx: _objectSpread({
      position: 'absolute',
      bottom: '0.2em',
      right: 0,
      fontSize: '0.5em',
      fontWeight: 'gw2.body',
      fontFamily: 'gw2.body',
      lineHeight: 1,
      color: '#fff',
      textShadow: '1px 1px 1px black'
    }, applyCountProps === null || applyCountProps === void 0 ? void 0 : applyCountProps.sx)
  }), applyCount));
});
Icon.propTypes = {
  component: _propTypes["default"].elementType,
  src: _propTypes["default"].string,
  name: _propTypes["default"].string,
  applyCount: _propTypes["default"].number,
  zoom: _propTypes["default"].number,
  inline: _propTypes["default"].bool,
  gutterRight: _propTypes["default"].bool,
  gutterLeft: _propTypes["default"].bool,
  hexagon: _propTypes["default"].bool,
  inactive: _propTypes["default"].bool,
  loading: _propTypes["default"].bool,
  spinnerProps: _propTypes["default"].object,
  applyCountProps: _propTypes["default"].object
};
Icon.defaultProps = {
  component: 'span',
  src: null,
  name: null,
  applyCount: null,
  zoom: null,
  inline: true,
  gutterRight: false,
  gutterLeft: false,
  hexagon: false,
  inactive: false,
  loading: false,
  spinnerProps: {},
  applyCountProps: {}
};
Icon.displayName = 'Icon';

var _default = (0, _withAsyncProp["default"])(function (_ref2) {
  var src = _ref2.src,
      name = _ref2.name;
  return !src && name && {
    src: Promise.resolve().then(function () {
      return (0, _interopRequireWildcard2["default"])(require("../assets/images/icons/".concat("".concat(name).replace('.', '/').replace(/[^\w\\/]/g, ''), ".png")));
    }).then(function (_ref3) {
      var module = _ref3["default"];
      return module;
    })
  };
}, ['name'])(Icon);

exports["default"] = _default;
//# sourceMappingURL=Icon.js.map