"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _Progress = _interopRequireDefault(require("../Progress"));

var _core = require("@theme-ui/core");

var IconWithText = (0, _react.forwardRef)(function (_ref, ref) {
  var Component = _ref.component,
      icon = _ref.icon,
      iconPosition = _ref.iconPosition,
      text = _ref.text,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      inline = _ref.inline,
      iconProps = _ref.iconProps,
      textProps = _ref.textProps,
      progressProps = _ref.progressProps,
      loading = _ref.loading,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["component", "icon", "iconPosition", "text", "disableIcon", "disableText", "inline", "iconProps", "textProps", "progressProps", "loading"]);
  return (0, _core.jsx)(Component, (0, _extends2["default"])({
    sx: {
      color: 'text',
      fontFamily: 'gw2.body',
      fontWeight: 'gw2.body',
      lineHeight: 'gw2.body'
    }
  }, rest, {
    ref: ref
  }), !disableIcon && iconPosition === 'left' && (loading || typeof icon === 'string' || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.src) || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.name) ? (0, _core.jsx)(_Icon["default"], (0, _extends2["default"])({
    src: icon,
    gutterRight: !disableText,
    inline: !disableText || inline,
    loading: loading
  }, iconProps)) : icon), !disableText && (loading ? (0, _core.jsx)(_Progress["default"], (0, _extends2["default"])({
    inline: !disableText || inline
  }, progressProps)) : (0, _core.jsx)("span", textProps, text)), !disableIcon && iconPosition === 'right' && (loading || typeof icon === 'string' || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.src) || (iconProps === null || iconProps === void 0 ? void 0 : iconProps.name) ? (0, _core.jsx)(_Icon["default"], (0, _extends2["default"])({
    src: icon,
    gutterLeft: !disableText,
    inline: !disableText || inline,
    loading: loading
  }, iconProps)) : icon));
});
IconWithText.propTypes = {
  component: _propTypes["default"].elementType,
  icon: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  iconPosition: _propTypes["default"].oneOf(['left', 'right']),
  text: _propTypes["default"].node,
  disableIcon: _propTypes["default"].bool,
  disableText: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  iconProps: _propTypes["default"].object,
  textProps: _propTypes["default"].object,
  progressProps: _propTypes["default"].object,
  loading: _propTypes["default"].bool
};
IconWithText.defaultProps = {
  component: 'span',
  icon: null,
  iconPosition: 'left',
  text: null,
  disableIcon: false,
  disableText: false,
  inline: true,
  iconProps: {},
  textProps: {},
  progressProps: {},
  loading: false
};
IconWithText.displayName = 'IconWithText';
var _default = IconWithText;
exports["default"] = _default;
//# sourceMappingURL=IconWithText.js.map