"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _index = _interopRequireDefault(require("../withLoading/index"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _IconWithText = _interopRequireDefault(require("../IconWithText"));

var _WikiLink = _interopRequireDefault(require("../WikiLink"));

var _ItemDetails = _interopRequireDefault(require("../ItemDetails"));

var _helpers = require("../helpers");

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Item = (0, _react.forwardRef)(function (_ref, ref) {
  var _tooltipProps$contain;

  var id = _ref.id,
      count = _ref.count,
      data = _ref.data,
      component = _ref.component,
      upgrades = _ref.upgrades,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      disableLink = _ref.disableLink,
      disableTooltip = _ref.disableTooltip,
      inline = _ref.inline,
      tooltipProps = _ref.tooltipProps,
      wikiLinkProps = _ref.wikiLinkProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["id", "count", "data", "component", "upgrades", "disableIcon", "disableText", "disableLink", "disableTooltip", "inline", "tooltipProps", "wikiLinkProps"]);
  var highlightSuffix = (0, _helpers.useColorModeHighlightSuffix)();
  var name = data.name,
      icon = data.icon,
      rarity = data.rarity,
      type = data.type,
      _data$details = data.details;
  _data$details = _data$details === void 0 ? {} : _data$details;
  var detailsType = _data$details.type;
  return (0, _core.jsx)(_Tooltip["default"], (0, _extends2["default"])({
    content: (0, _core.jsx)(_ItemDetails["default"], {
      data: data,
      count: count,
      upgrades: upgrades && upgrades.map(function (_ref2, index) {
        var upgradeId = _ref2.id,
            upgradeData = _ref2.data,
            upgradeLoading = _ref2.loading,
            upgradeError = _ref2.error,
            upgradeBonusCount = _ref2.count;
        return (0, _core.jsx)("div", {
          key: "".concat(upgradeId, "-").concat(index),
          sx: _objectSpread({
            mt: '16px'
          }, index < upgrades.length && {
            mb: '16px'
          })
        }, (0, _core.jsx)(_ItemDetails["default"], {
          upgrade: true,
          id: upgradeId,
          loading: upgradeLoading,
          error: upgradeError,
          data: upgradeData,
          upgradeBonusCount: upgradeBonusCount
        }));
      })
    }),
    disabled: disableTooltip
  }, tooltipProps, {
    containerProps: _objectSpread({}, tooltipProps.containerProps, {
      sx: _objectSpread({
        maxWidth: 353
      }, (_tooltipProps$contain = tooltipProps.containerProps) === null || _tooltipProps$contain === void 0 ? void 0 : _tooltipProps$contain.sx)
    })
  }), (0, _core.jsx)(_IconWithText["default"], (0, _extends2["default"])({
    component: component,
    icon: icon,
    text: (0, _core.jsx)(_react["default"].Fragment, null, count > 1 && "".concat(count, " "), disableLink ? name : (0, _core.jsx)(_WikiLink["default"], (0, _extends2["default"])({
      to: name
    }, wikiLinkProps, {
      sx: _objectSpread({
        color: 'inherit',
        '&:hover': {
          color: "gw2.rarity.".concat(rarity.toLowerCase()).concat(highlightSuffix)
        }
      }, wikiLinkProps === null || wikiLinkProps === void 0 ? void 0 : wikiLinkProps.sx)
    }))),
    disableIcon: disableIcon,
    disableText: disableText,
    inline: inline
  }, rest, {
    iconProps: _objectSpread({}, type && detailsType && {
      name: "".concat(type, ".").concat(detailsType)
    }, {
      applyCount: count,
      applyCountProps: {
        sx: {
          top: '0.1em',
          right: '0.1em',
          bottom: 'initial',
          color: "#fee49a"
        }
      }
    }, rest.iconProps),
    sx: _objectSpread({
      color: "gw2.rarity.".concat(rarity.toLowerCase())
    }, rest.sx),
    ref: ref
  })));
});
Item.propTypes = {
  id: _propTypes["default"].number,
  count: _propTypes["default"].number,
  component: _propTypes["default"].elementType,
  data: _propTypes["default"].object.isRequired,
  disableIcon: _propTypes["default"].bool,
  disableText: _propTypes["default"].bool,
  disableLink: _propTypes["default"].bool,
  disableTooltip: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  tooltipProps: _propTypes["default"].object,
  wikiLinkProps: _propTypes["default"].object,
  upgrades: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    data: _propTypes["default"].object,
    loading: _propTypes["default"].bool,
    error: _propTypes["default"].shape({
      code: _propTypes["default"].string,
      name: _propTypes["default"].string,
      message: _propTypes["default"].string
    }),
    count: _propTypes["default"].number
  }))
};
Item.defaultProps = {
  id: null,
  count: null,
  component: undefined,
  disableIcon: false,
  disableText: false,
  disableLink: false,
  disableTooltip: false,
  inline: true,
  tooltipProps: {},
  wikiLinkProps: {},
  upgrades: null
};
Item.displayName = 'Item';

var _default = (0, _index["default"])()(Item);

exports["default"] = _default;
//# sourceMappingURL=Item.js.map