"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _index = _interopRequireDefault(require("../withLoading/index"));

var _DetailsHeader = _interopRequireDefault(require("../DetailsHeader"));

var _DetailsText = _interopRequireDefault(require("../DetailsText"));

var _helpers = require("../helpers");

var _Coin = _interopRequireDefault(require("../Coin"));

var _DetailsFact = _interopRequireDefault(require("../DetailsFact"));

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ItemDetails = (0, _react.forwardRef)(function (_ref, ref) {
  var count = _ref.count,
      upgrade = _ref.upgrade,
      upgrades = _ref.upgrades,
      upgradeBonusCount = _ref.upgradeBonusCount,
      _ref$data = _ref.data,
      icon = _ref$data.icon,
      name = _ref$data.name,
      rarity = _ref$data.rarity,
      level = _ref$data.level,
      description = _ref$data.description,
      _ref$data$flags = _ref$data.flags,
      flags = _ref$data$flags === void 0 ? [] : _ref$data$flags,
      type = _ref$data.type,
      _ref$data$details = _ref$data.details;
  _ref$data$details = _ref$data$details === void 0 ? {} : _ref$data$details;
  var detailsIcon = _ref$data$details.icon,
      detailsName = _ref$data$details.name,
      detailsType = _ref$data$details.type,
      detailsDuration = _ref$data$details.duration_ms,
      detailsDescription = _ref$data$details.description,
      minPower = _ref$data$details.min_power,
      maxPower = _ref$data$details.max_power,
      defense = _ref$data$details.defense,
      weightClass = _ref$data$details.weight_class,
      _ref$data$details$inf = _ref$data$details.infusion_upgrade_flags,
      infusionUpgradeFlags = _ref$data$details$inf === void 0 ? [] : _ref$data$details$inf,
      _ref$data$details$inf2 = _ref$data$details.infix_upgrade;
  _ref$data$details$inf2 = _ref$data$details$inf2 === void 0 ? {} : _ref$data$details$inf2;
  var attributes = _ref$data$details$inf2.attributes,
      _ref$data$details$inf3 = _ref$data$details$inf2.buff;
  _ref$data$details$inf3 = _ref$data$details$inf3 === void 0 ? {} : _ref$data$details$inf3;
  var buffDescription = _ref$data$details$inf3.description,
      bonuses = _ref$data$details.bonuses,
      vendorValue = _ref$data.vendor_value,
      ignoredId = _ref.id,
      ignoredComponent = _ref.component,
      ignoredDisableIcon = _ref.disableIcon,
      ignoredDisableText = _ref.disableText,
      ignoredDisableTooltip = _ref.disableTooltip,
      ignoredInline = _ref.inline,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["count", "upgrade", "upgrades", "upgradeBonusCount", "data", "id", "component", "disableIcon", "disableText", "disableTooltip", "inline"]);
  return (0, _core.jsx)("div", (0, _extends2["default"])({}, rest, {
    ref: ref
  }), (0, _core.jsx)(_DetailsHeader["default"], (0, _extends2["default"])({
    icon: icon,
    iconProps: _objectSpread({}, type && detailsType && {
      name: "".concat(type, ".").concat(detailsType)
    }, {}, upgrade && {
      sx: {
        border: 'none',
        fontSize: '16px'
      }
    }),
    titleProps: {
      sx: _objectSpread({
        color: rarity === 'Basic' ? '#fff' : "gw2.rarity.".concat(rarity.toLowerCase())
      }, upgrade && {
        color: 'gw2.details.bonus',
        fontSize: '14px',
        fontWeight: 'gw2.body'
      })
    }
  }, upgrade ? {
    sx: {
      mb: '1px'
    }
  } : _objectSpread({}, (!attributes && buffDescription || attributes && infusionUpgradeFlags.includes('Infusion')) && {
    sx: {
      mb: '16px'
    }
  })), count > 1 && "".concat(count, " "), name, upgrade && upgradeBonusCount >= 0 && bonuses && bonuses.length ? " (".concat(Math.min(upgradeBonusCount, bonuses.length), "/").concat(bonuses.length, ")") : ''), (0, _core.jsx)("div", null, type === 'Consumable' && (0, _core.jsx)("div", null, "Double-click to consume."), minPower !== undefined && maxPower !== undefined && (0, _core.jsx)("div", null, "Weapon Strength: ", (0, _core.jsx)("span", {
    sx: {
      color: 'gw2.details.attribute'
    }
  }, "".concat(minPower, " - ").concat(maxPower))), defense > 0 && (0, _core.jsx)("div", null, "Defense: ", (0, _core.jsx)("span", {
    sx: {
      color: 'gw2.details.attribute'
    }
  }, defense)), attributes && attributes.length > 0 && attributes.map(function (_ref2) {
    var attribute = _ref2.attribute,
        modifier = _ref2.modifier;
    return (0, _core.jsx)("div", {
      key: "".concat(attribute, "-").concat(modifier)
    }, (0, _core.jsx)("span", {
      sx: {
        color: upgrade || infusionUpgradeFlags.includes('Infusion') ? 'gw2.details.bonus' : 'gw2.details.attribute'
      }
    }, "+".concat(modifier, " ").concat(_helpers.apiAttributes[attribute])));
  }), (!attributes || !attributes.length) && (buffDescription || !upgrade && description) && (0, _core.jsx)(_DetailsText["default"], {
    lines: [buffDescription || !upgrade && description],
    sx: _objectSpread({}, type === 'UpgradeComponent' && {
      color: 'gw2.details.bonus'
    })
  }), bonuses && bonuses.length > 0 && bonuses.map(function (bonus, index) {
    return (0, _core.jsx)("div", {
      key: bonus,
      sx: {
        color: upgradeBonusCount > index ? 'gw2.details.bonus' : 'gw2.details.bonusInactive'
      }
    }, (0, _core.jsx)("span", null, "(", index + 1, "): "), bonus);
  })), upgrades && (0, _core.jsx)("div", null, upgrades), detailsIcon && detailsName && detailsDuration && detailsDescription && (0, _core.jsx)(_DetailsFact["default"], {
    data: {
      type: 'Buff',
      icon: detailsIcon,
      duration: detailsDuration / 1000,
      description: detailsDescription,
      status: detailsName
    },
    sx: {
      mb: '12px'
    }
  }), !upgrade && (0, _core.jsx)(_DetailsText["default"], {
    lines: [].concat((0, _toConsumableArray2["default"])(type === 'UpgradeComponent' ? [description, level > 0 && "Required Level: ".concat(level)] : (0, _toConsumableArray2["default"])(type === 'Consumable' ? [type, level > 0 && "Required Level: ".concat(level)] : [rarity, weightClass, detailsType, level > 0 && "Required Level: ".concat(level), (attributes && attributes.length || buffDescription) && description, flags.includes('Unique') && 'Unique', flags.includes('AccountBound') && 'Account Bound', flags.includes('Soulbound') && 'Soulbound'])), (0, _toConsumableArray2["default"])(infusionUpgradeFlags.includes('Infusion') ? [] : [vendorValue > 0 && !flags.includes('NoSell') && (0, _core.jsx)(_Coin["default"], {
      value: vendorValue
    })]))
  }));
});
ItemDetails.propTypes = {
  count: _propTypes["default"].number,
  upgrade: _propTypes["default"].bool,
  upgrades: _propTypes["default"].node,
  upgradeBonusCount: _propTypes["default"].number,
  data: _propTypes["default"].object.isRequired
};
ItemDetails.defaultProps = {
  count: null,
  upgrade: false,
  upgrades: null,
  upgradeBonusCount: null
};
ItemDetails.displayName = 'ItemDetails';

var _default = (0, _index["default"])({
  disableTooltip: true,
  iconWithTextProps: {
    sx: {
      color: '#fff'
    }
  }
})(ItemDetails);

exports["default"] = _default;
//# sourceMappingURL=ItemDetails.js.map