"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _IconWithText = _interopRequireDefault(require("../IconWithText"));

var _WikiLink = _interopRequireDefault(require("../WikiLink"));

var _Error = _interopRequireDefault(require("../Error"));

var _races = _interopRequireDefault(require("../data/races.json"));

var _helpers = require("../helpers");

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Race = (0, _react.forwardRef)(function (_ref, ref) {
  var name = _ref.name,
      component = _ref.component,
      disableTooltip = _ref.disableTooltip,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      disableLink = _ref.disableLink,
      inline = _ref.inline,
      wikiLinkProps = _ref.wikiLinkProps,
      tooltipProps = _ref.tooltipProps,
      errorProps = _ref.errorProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["name", "component", "disableTooltip", "disableIcon", "disableText", "disableLink", "inline", "wikiLinkProps", "tooltipProps", "errorProps"]);
  var highlightSuffix = (0, _helpers.useColorModeHighlightSuffix)();

  if (!name || !_races["default"].includes(name)) {
    return (0, _core.jsx)(_Error["default"], (0, _extends2["default"])({
      name: "Invalid Race".concat(name ? " ".concat(name) : ''),
      message: "Error: No data for Race".concat(name ? " ".concat(name) : ''),
      disableTooltip: disableTooltip,
      disableIcon: disableIcon,
      disableText: disableText,
      inline: inline,
      iconProps: {
        name: '404'
      }
    }, errorProps, {
      style: _objectSpread({}, rest.style, {}, errorProps === null || errorProps === void 0 ? void 0 : errorProps.style),
      className: (0, _classnames["default"])(rest.className, errorProps.className),
      sx: _objectSpread({}, rest.sx, {}, errorProps === null || errorProps === void 0 ? void 0 : errorProps.sx)
    }));
  }

  return (0, _core.jsx)(_IconWithText["default"], (0, _extends2["default"])({
    component: component,
    text: disableLink ? name : (0, _core.jsx)(_WikiLink["default"], (0, _extends2["default"])({
      to: name
    }, wikiLinkProps, {
      sx: _objectSpread({
        color: 'inherit',
        '&:hover': {
          color: "gw2.race.".concat(name.toLowerCase()).concat(highlightSuffix)
        }
      }, wikiLinkProps === null || wikiLinkProps === void 0 ? void 0 : wikiLinkProps.sx)
    })),
    disableIcon: disableIcon,
    disableText: disableText,
    inline: inline
  }, rest, {
    iconProps: _objectSpread({
      name: "Race.".concat(name)
    }, rest.iconProps),
    sx: _objectSpread({
      color: "gw2.race.".concat(name.toLowerCase())
    }, rest.sx),
    ref: ref
  }));
});
Race.propTypes = {
  name: _propTypes["default"].oneOf(_races["default"]).isRequired,
  component: _propTypes["default"].elementType,
  disableTooltip: _propTypes["default"].bool,
  disableIcon: _propTypes["default"].bool,
  disableText: _propTypes["default"].bool,
  disableLink: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  tooltipProps: _propTypes["default"].object,
  wikiLinkProps: _propTypes["default"].object,
  errorProps: _propTypes["default"].object
};
Race.defaultProps = {
  component: undefined,
  disableTooltip: false,
  disableIcon: false,
  disableText: false,
  disableLink: false,
  inline: true,
  tooltipProps: {},
  wikiLinkProps: {},
  errorProps: {}
};
Race.displayName = 'Race';
var _default = Race;
exports["default"] = _default;
//# sourceMappingURL=Race.js.map