"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _index = _interopRequireDefault(require("../withLoading/index"));

var _IconWithText = _interopRequireDefault(require("../IconWithText"));

var _WikiLink = _interopRequireDefault(require("../WikiLink"));

var _helpers = require("../helpers");

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Specialization = (0, _react.forwardRef)(function (_ref, ref) {
  var id = _ref.id,
      data = _ref.data,
      component = _ref.component,
      disableIcon = _ref.disableIcon,
      disableText = _ref.disableText,
      disableLink = _ref.disableLink,
      inline = _ref.inline,
      wikiLinkProps = _ref.wikiLinkProps,
      ignoredDisableTooltip = _ref.disableTooltip,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["id", "data", "component", "disableIcon", "disableText", "disableLink", "inline", "wikiLinkProps", "disableTooltip"]);
  var highlightSuffix = (0, _helpers.useColorModeHighlightSuffix)();
  var name = data.name,
      icon = data.icon,
      profession = data.profession;
  return (0, _core.jsx)(_IconWithText["default"], (0, _extends2["default"])({
    component: component,
    icon: icon,
    text: disableLink ? name : (0, _core.jsx)(_WikiLink["default"], (0, _extends2["default"])({
      to: name
    }, wikiLinkProps, {
      sx: _objectSpread({
        color: 'inherit',
        '&:hover': {
          color: "gw2.profession.".concat(profession.toLowerCase()).concat(highlightSuffix)
        }
      }, wikiLinkProps === null || wikiLinkProps === void 0 ? void 0 : wikiLinkProps.sx)
    })),
    disableIcon: disableIcon,
    disableText: disableText,
    inline: inline
  }, rest, {
    iconProps: _objectSpread({
      hexagon: true
    }, rest.iconProps),
    sx: _objectSpread({
      color: "gw2.profession.".concat(profession.toLowerCase())
    }, rest.sx),
    ref: ref
  }));
});
Specialization.propTypes = {
  id: _propTypes["default"].number,
  component: _propTypes["default"].elementType,
  data: _propTypes["default"].object.isRequired,
  disableIcon: _propTypes["default"].bool,
  disableText: _propTypes["default"].bool,
  disableLink: _propTypes["default"].bool,
  inline: _propTypes["default"].bool,
  wikiLinkProps: _propTypes["default"].object
};
Specialization.defaultProps = {
  id: null,
  component: undefined,
  disableIcon: false,
  disableText: false,
  disableLink: false,
  inline: true,
  wikiLinkProps: {}
};
Specialization.displayName = 'Specialization';

var _default = (0, _index["default"])()(Specialization);

exports["default"] = _default;
//# sourceMappingURL=Specialization.js.map