"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _headless = _interopRequireDefault(require("@tippyjs/react/headless"));

var _headless2 = require("tippy.js/headless");

var _TooltipContainer = _interopRequireDefault(require("../TooltipContainer"));

var _core = require("@theme-ui/core");

var Tooltip = (0, _react.forwardRef)(function (_ref, ref) {
  var propsContent = _ref.content,
      _render = _ref.render,
      containerProps = _ref.containerProps,
      wrapperProps = _ref.wrapperProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["content", "render", "containerProps", "wrapperProps"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      mounted = _useState2[0],
      setMounted = _useState2[1];

  var lazyPlugin = {
    fn: function fn() {
      return {
        onShow: function onShow() {
          return setMounted(true);
        },
        onHidden: function onHidden() {
          return setMounted(false);
        }
      };
    }
  };
  return (0, _core.jsx)(_headless["default"], (0, _extends2["default"])({
    ignoreAttributes: true,
    followCursor: true,
    plugins: [lazyPlugin, _headless2.followCursor],
    render: function render(attrs) {
      if (!mounted) {
        return null;
      }

      var content = null;

      if (propsContent) {
        content = (0, _core.jsx)(_TooltipContainer["default"], containerProps, propsContent);
      } else if (typeof _render === 'function') {
        content = _render();
      } else if (_render != null) {
        content = _render;
      }

      return (0, _core.jsx)("div", (0, _extends2["default"])({
        sx: {
          maxHeight: 'calc(100vh - 20px)',
          display: 'flex',
          flexDirection: 'column',
          flexWrap: 'wrap',
          zIndex: 'tooltip'
        },
        tabIndex: "-1"
      }, wrapperProps, attrs), content);
    }
  }, rest, {
    ref: ref
  }));
});
Tooltip.propTypes = {
  content: _propTypes["default"].node,
  render: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].node]),
  containerProps: _propTypes["default"].object,
  wrapperProps: _propTypes["default"].object
};
Tooltip.defaultProps = {
  content: null,
  render: null,
  containerProps: {},
  wrapperProps: {}
};
Tooltip.displayName = 'Tooltip';
var _default = Tooltip;
exports["default"] = _default;
//# sourceMappingURL=Tooltip.js.map