"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withLoading = _interopRequireDefault(require("../withLoading"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _TraitLineConnector = _interopRequireWildcard(require("../TraitLineConnector"));

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var renderTraitLineConnector = function renderTraitLineConnector() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      css = _ref.css,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["css"]);

  return (0, _core.jsx)(_TraitLineConnector["default"], (0, _extends2["default"])({}, rest, {
    css: _objectSpread({
      alignSelf: 'stretch',
      flexGrow: 1,
      minWidth: 13,
      maxWidth: 36
    }, css)
  }));
};

var TraitLine = (0, _react.forwardRef)(function (_ref2, ref) {
  var id = _ref2.id,
      TraitComponent = _ref2.traitComponent,
      defaultSelected = _ref2.defaultSelected,
      propsSelected = _ref2.selected,
      onSelect = _ref2.onSelect,
      selectable = _ref2.selectable,
      resettable = _ref2.resettable,
      onReset = _ref2.onReset,
      _ref2$data = _ref2.data,
      background = _ref2$data.background,
      name = _ref2$data.name,
      minorTraits = _ref2$data.minor_traits,
      majorTraits = _ref2$data.major_traits,
      ignoredComponent = _ref2.component,
      ignoredDisableIcon = _ref2.disableIcon,
      ignoredDisableText = _ref2.disableText,
      ignoredDisableTooltip = _ref2.disableTooltip,
      ignoredInline = _ref2.inline,
      rest = (0, _objectWithoutProperties2["default"])(_ref2, ["id", "traitComponent", "defaultSelected", "selected", "onSelect", "selectable", "resettable", "onReset", "data", "component", "disableIcon", "disableText", "disableTooltip", "inline"]);

  var _useState = (0, _react.useState)(defaultSelected),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      uncontrolledSelected = _useState2[0],
      setUncontrolledSelected = _useState2[1];

  (0, _react.useEffect)(function () {
    setUncontrolledSelected(defaultSelected);
  }, (0, _toConsumableArray2["default"])(defaultSelected));
  var controlled = typeof onSelect === 'function';
  var selected;

  if (controlled) {
    selected = propsSelected;
  } else if (selectable) {
    selected = uncontrolledSelected;
  } else {
    selected = defaultSelected || propsSelected;
  }

  var renderMinorTrait = (0, _react.useCallback)(function (_ref3) {
    var minorTraitId = _ref3.id;
    return (0, _core.jsx)(TraitComponent, {
      key: minorTraitId,
      id: minorTraitId,
      sx: {
        fontSize: '40px',
        display: 'inline-flex',
        color: 'rgba(255,255,255,0.5)'
      },
      iconProps: {
        hexagon: true
      },
      disableText: true,
      inline: false
    });
  }, TraitComponent);
  var renderMajorTrait = (0, _react.useCallback)(function (_ref4) {
    var tier = _ref4.tier,
        majorTraitId = _ref4.id,
        isSelected = _ref4.selected,
        majorTraitIndex = _ref4.index;
    return (0, _core.jsx)(TraitComponent, _objectSpread({
      key: majorTraitId,
      id: majorTraitId,
      sx: _objectSpread({
        fontSize: '37px',
        display: 'inline-flex',
        color: 'rgba(255,255,255,0.5)'
      }, !isSelected && (controlled || selectable) && {
        cursor: 'pointer'
      }),
      disableText: true,
      inline: false,
      inactive: !isSelected
    }, !isSelected && (controlled || selectable) && {
      onClick: function onClick(event) {
        event.preventDefault();

        if (controlled) {
          onSelect({
            tier: tier,
            id: majorTraitId,
            index: majorTraitIndex
          });
        } else {
          var selectedIndexToReplace = selected.findIndex(function (selectedMajorTraitId) {
            return majorTraits.slice(tier * 3, tier * 3 + 3).includes(selectedMajorTraitId);
          });

          if (selectedIndexToReplace !== -1) {
            setUncontrolledSelected(selected.map(function (value, index) {
              return index === selectedIndexToReplace ? majorTraitId : value;
            }));
          } else {
            var selectedIndexBelowToAppend = tier > 0 && selected.findIndex(function (selectedMajorTraitId) {
              return majorTraits.slice((tier - 1) * 3, (tier - 1) * 3 + 3).includes(selectedMajorTraitId);
            });

            if (selectedIndexBelowToAppend !== -1) {
              var newSelected = (0, _toConsumableArray2["default"])(selected);
              newSelected.splice(selectedIndexBelowToAppend + 1, 0, majorTraitId);
              setUncontrolledSelected(newSelected);
            } else {
              var selectedIndexAboveToPrepend = tier < 2 && selected.findIndex(function (selectedMajorTraitId) {
                return majorTraits.slice((tier + 1) * 3, (tier + 1) * 3 + 3).includes(selectedMajorTraitId);
              });

              if (selectedIndexAboveToPrepend !== -1) {
                var _newSelected = (0, _toConsumableArray2["default"])(selected);

                _newSelected.splice(selectedIndexBelowToAppend, 0, majorTraitId);

                setUncontrolledSelected(_newSelected);
              } else {
                setUncontrolledSelected([].concat((0, _toConsumableArray2["default"])(selected), [majorTraitId]));
              }
            }
          }
        }
      }
    }));
  }, [TraitComponent, controlled, selectable].concat((0, _toConsumableArray2["default"])(selected)));
  return (0, _core.jsx)("div", (0, _extends2["default"])({
    css: {
      position: 'relative',
      width: '100%',
      maxWidth: 650,
      height: 135,
      border: '1px solid #0b0e14',
      backgroundColor: 'rgb(0,0,0)',
      display: 'flex',
      boxSizing: 'border-box',
      overflow: 'hidden',
      '::before': {
        content: '""',
        position: 'absolute',
        minWidth: '100%',
        width: 460,
        height: '100%',
        backgroundPosition: 'left bottom',
        backgroundRepeat: 'no-repeat',
        backgroundImage: "url('".concat(background, "')"),
        right: 0
      }
    }
  }, rest, {
    ref: ref
  }), (0, _core.jsx)("div", {
    css: {
      position: 'absolute',
      minWidth: '100%',
      height: '100%',
      right: 0,
      display: 'flex'
    }
  }, (0, _core.jsx)("div", {
    css: {
      width: 168,
      filter: 'drop-shadow(2px 2px 5px black)',
      display: 'flex',
      alignItems: 'center'
    }
  }, (0, _core.jsx)(_Tooltip["default"], {
    content: name
  }, (0, _core.jsx)("span", {
    css: {
      position: 'absolute',
      marginLeft: 73,
      height: 55,
      width: 95,
      boxSizing: 'border-box',
      '&, ::before, ::after': {
        borderWidth: 0,
        borderStyle: 'solid',
        borderColor: 'rgba(255,255,255,0.5)'
      },
      '&': {
        borderLeftWidth: 2,
        borderRightWidth: 2
      },
      '::before, ::after': {
        content: "''",
        position: 'absolute',
        width: 64,
        height: 64,
        transform: 'scaleY(0.5774) rotate(-45deg)',
        left: 12
      },
      '::before': {
        top: -33.5,
        borderTopWidth: 3,
        borderRightWidth: 3
      },
      '::after': {
        bottom: -33.5,
        borderBottomWidth: 3,
        borderLeftWidth: 3
      }
    }
  }))), (0, _core.jsx)("div", {
    sx: {
      py: '6px'
    },
    css: {
      display: 'flex',
      maxWidth: 430,
      paddingRight: '6px',
      flexGrow: 1,
      justifyContent: 'space-between',
      alignItems: 'center',
      position: 'relative'
    }
  }, majorTraits.reduce(function (array, item, index) {
    return index % 3 === 0 ? [].concat((0, _toConsumableArray2["default"])(array), [[item]]) : [].concat((0, _toConsumableArray2["default"])(array.slice(0, -1)), [[].concat((0, _toConsumableArray2["default"])(array.slice(-1)[0]), [item])]);
  }, []).map(function (majorTraitsChunk, tier) {
    var selectedMajorTraitIndex = majorTraitsChunk.findIndex(function (majorTraitId) {
      return selected.includes(majorTraitId);
    });
    var path = Object.values(_TraitLineConnector.Paths)[selectedMajorTraitIndex];
    return (0, _core.jsx)(_react.Fragment, {
      key: tier
    }, tier === 0 && renderTraitLineConnector({
      css: {
        maxWidth: 33
      }
    }), renderMinorTrait({
      id: minorTraits[tier],
      tier: tier
    }), renderTraitLineConnector(path !== undefined ? {
      end: path
    } : {
      disabled: true
    }), (0, _core.jsx)("div", {
      sx: {
        display: 'flex',
        flexDirection: 'column',
        height: '100%',
        justifyContent: 'space-between',
        alignItems: 'center'
      }
    }, majorTraitsChunk.map(function (majorTraitId, majorTraitIndex) {
      return renderMajorTrait({
        tier: tier,
        id: majorTraitId,
        selected: majorTraitIndex === selectedMajorTraitIndex,
        index: majorTraitIndex
      });
    })), tier !== 2 && renderTraitLineConnector(path !== undefined ? {
      start: path
    } : {
      disabled: true
    }));
  }))), onReset || !controlled && selectable && resettable && JSON.stringify(uncontrolledSelected) !== JSON.stringify(defaultSelected) && (0, _core.jsx)(_Tooltip["default"], {
    content: "Reset"
  }, (0, _core.jsx)("div", {
    sx: {
      position: 'absolute',
      boxSizing: 'border-box',
      top: 2,
      left: 2,
      cursor: 'pointer'
    }
  }, (0, _core.jsx)(_Icon["default"], {
    name: "Reset",
    inactive: true,
    sx: {
      fontSize: '32px',
      border: '1px solid rgba(255,255,255,0.5)'
    },
    onClick: function onClick(event) {
      event.preventDefault();

      if (!controlled) {
        setUncontrolledSelected(defaultSelected);
      }

      if (typeof onReset === 'function') {
        onReset();
      }
    }
  }))));
});
TraitLine.propTypes = {
  id: _propTypes["default"].number,
  traitComponent: _propTypes["default"].elementType.isRequired,
  defaultSelected: _propTypes["default"].arrayOf(_propTypes["default"].number),
  selected: _propTypes["default"].arrayOf(_propTypes["default"].number),
  selectable: _propTypes["default"].bool,
  resettable: _propTypes["default"].bool,
  onReset: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  data: _propTypes["default"].object.isRequired
};
TraitLine.defaultProps = {
  id: null,
  defaultSelected: [],
  selected: [],
  selectable: true,
  resettable: true,
  onReset: null,
  onSelect: null
};
TraitLine.displayName = 'TraitLine';

var _default = (0, _withLoading["default"])({
  iconWithTextProps: {
    sx: {
      width: '100%',
      maxWidth: '650px',
      height: '135px',
      backgroundColor: 'rgba(0,0,0,0.2)',
      border: '1px solid rgb(9, 10, 14)',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      fontSize: '34px'
    }
  },
  errorProps: {
    sx: {
      width: '100%',
      maxWidth: '650px',
      height: '135px',
      backgroundColor: 'rgba(0,0,0,0.2)',
      border: '1px solid rgb(9, 10, 14)',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      fontSize: '34px'
    }
  }
})(TraitLine);

exports["default"] = _default;
//# sourceMappingURL=TraitLine.js.map