"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Paths = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactResizeAware = _interopRequireDefault(require("react-resize-aware"));

var _core = require("@emotion/core");

var _traitLineConnector = _interopRequireDefault(require("../assets/images/trait-line-connector.png"));

var _core2 = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var move = (0, _core.keyframes)({
  from: {
    backgroundPositionX: 0
  },
  to: {
    backgroundPositionX: -300
  }
});
var Paths = {
  UP: 'up',
  MID: 'mid',
  DOWN: 'down'
};
exports.Paths = Paths;
var TraitLineConnector = (0, _react.forwardRef)(function (_ref, ref) {
  var start = _ref.start,
      end = _ref.end,
      disabled = _ref.disabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["start", "end", "disabled"]);

  var _useResizeAware = (0, _reactResizeAware["default"])(),
      _useResizeAware2 = (0, _slicedToArray2["default"])(_useResizeAware, 2),
      resizeListener = _useResizeAware2[0],
      _useResizeAware2$ = _useResizeAware2[1],
      width = _useResizeAware2$.width,
      height = _useResizeAware2$.height;

  var _useState = (0, _react.useState)({}),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      dimensions = _useState2[0],
      setDimensions = _useState2[1];

  (0, _react.useEffect)(function () {
    var startY;

    switch (start) {
      case Paths.UP:
        startY = height - 18.5;
        break;

      case Paths.MID:
        startY = height * 0.5;

        if (end === Paths.UP) {
          startY += 4;
        } else if (end === Paths.DOWN) {
          startY -= 4;
        }

        break;

      case Paths.DOWN:
        startY = 18.5;
        break;

      default:
        break;
    }

    var endY;

    switch (end) {
      case Paths.UP:
        endY = height - 18.5;
        break;

      case Paths.MID:
        endY = height * 0.5;

        if (start === Paths.UP) {
          endY += 4;
        } else if (start === Paths.DOWN) {
          endY -= 4;
        }

        break;

      case Paths.DOWN:
        endY = 18.5;
        break;

      default:
        break;
    }

    var length = Math.sqrt(Math.pow(width, 2) + Math.pow(startY - endY, 2));
    setDimensions({
      bottom: (startY + endY) / 2 - 8 / 2,
      left: width / 2 - length / 2,
      length: length,
      angle: Math.atan2(endY - startY, -width) * (180 / Math.PI)
    });
  }, [start, end, width, height]);

  if (!dimensions) {
    return null;
  }

  var bottom = dimensions.bottom,
      left = dimensions.left,
      length = dimensions.length,
      angle = dimensions.angle;
  return (0, _core2.jsx)("div", (0, _extends2["default"])({
    sx: {
      position: 'relative'
    }
  }, rest, {
    ref: ref
  }), resizeListener, (0, _core2.jsx)("div", {
    sx: _objectSpread({
      position: 'absolute'
    }, !disabled && {
      backgroundImage: "url(".concat(_traitLineConnector["default"], ")"),
      backgroundRepeat: 'repeat-x',
      animation: "".concat(move.toString(), " 30s linear infinite")
    }),
    css: {
      height: 8,
      bottom: bottom,
      left: left,
      width: length,
      transform: "rotate(".concat(angle, "deg)")
    }
  }));
});
TraitLineConnector.propTypes = {
  start: _propTypes["default"].oneOf(Object.values(Paths)),
  end: _propTypes["default"].oneOf(Object.values(Paths)),
  disabled: _propTypes["default"].bool
};
TraitLineConnector.defaultProps = {
  start: Paths.MID,
  end: Paths.MID,
  disabled: false
};
TraitLineConnector.displayName = 'TraitLineConnector';
var _default = TraitLineConnector;
exports["default"] = _default;
//# sourceMappingURL=TraitLineConnector.js.map