"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.languages = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _helpers = require("../helpers");

var _core = require("@theme-ui/core");

var languages = ['en', 'zh', 'cs', 'nl', 'fi', 'fr', 'de', 'hu', 'it', 'ja', 'ko', 'ms', 'po', 'pt', 'ru', 'es', 'sv', 'tr', 'un'];
exports.languages = languages;
var WikiLink = (0, _react.forwardRef)(function (_ref, ref) {
  var Component = _ref.component,
      to = _ref.to,
      lang = _ref.lang,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["component", "to", "lang"]);
  var highlightSuffix = (0, _helpers.useColorModeHighlightSuffix)();
  return (0, _core.jsx)(Component, (0, _extends2["default"])({
    sx: {
      color: 'primary',
      textDecoration: 'none',
      transition: 'color 200ms ease-in-out',
      '&:hover': {
        color: "primary".concat(highlightSuffix)
      }
    },
    href: "https://wiki-".concat(lang, ".guildwars2.com/wiki/Special:Search/").concat(encodeURIComponent(to)),
    target: "_blank",
    rel: "noreferrer noopener nofollow"
  }, rest, {
    ref: ref
  }), to);
});
WikiLink.propTypes = {
  component: _propTypes["default"].elementType,
  to: _propTypes["default"].string.isRequired,
  lang: _propTypes["default"].oneOf(languages)
};
WikiLink.defaultProps = {
  component: 'a',
  lang: 'en'
};
WikiLink.displayName = 'WikiLink';
var _default = WikiLink;
exports["default"] = _default;
//# sourceMappingURL=WikiLink.js.map