"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Error = _interopRequireDefault(require("../Error"));

var _helpers = require("../helpers");

var _IconWithText = _interopRequireDefault(require("../IconWithText"));

var _core = require("@theme-ui/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _default = function _default() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$component = _ref.component,
      defaultComponent = _ref$component === void 0 ? undefined : _ref$component,
      _ref$disableIcon = _ref.disableIcon,
      defaultDisableIcon = _ref$disableIcon === void 0 ? false : _ref$disableIcon,
      _ref$disableText = _ref.disableText,
      defaultDisableText = _ref$disableText === void 0 ? false : _ref$disableText,
      _ref$disableTooltip = _ref.disableTooltip,
      defaultDisableTooltip = _ref$disableTooltip === void 0 ? false : _ref$disableTooltip,
      _ref$inline = _ref.inline,
      defaultInline = _ref$inline === void 0 ? true : _ref$inline,
      _ref$iconWithTextProp = _ref.iconWithTextProps,
      defaultIconWithTextProps = _ref$iconWithTextProp === void 0 ? {} : _ref$iconWithTextProp,
      _ref$errorProps = _ref.errorProps,
      defaultErrorProps = _ref$errorProps === void 0 ? {} : _ref$errorProps;

  return function (Component) {
    var displayName = (0, _helpers.getDisplayName)(Component);
    var WithLoading = (0, _react.forwardRef)(function (_ref2, ref) {
      var loading = _ref2.loading,
          error = _ref2.error,
          errorProps = _ref2.errorProps,
          iconWithTextProps = _ref2.iconWithTextProps,
          rest = (0, _objectWithoutProperties2["default"])(_ref2, ["loading", "error", "errorProps", "iconWithTextProps"]);

      var _rest = _objectSpread({}, rest),
          id = _rest.id,
          data = _rest.data,
          disableIcon = _rest.disableIcon,
          disableText = _rest.disableText,
          disableTooltip = _rest.disableTooltip,
          inline = _rest.inline,
          iconProps = _rest.iconProps;

      if (loading) {
        return (0, _core.jsx)(_IconWithText["default"], (0, _extends2["default"])({
          loading: loading,
          disableIcon: disableIcon,
          disableText: disableText,
          inline: inline
        }, iconWithTextProps, {
          iconProps: _objectSpread({}, iconWithTextProps === null || iconWithTextProps === void 0 ? void 0 : iconWithTextProps.iconProps, {}, iconProps)
        }, {
          style: _objectSpread({}, rest.style, {}, iconWithTextProps === null || iconWithTextProps === void 0 ? void 0 : iconWithTextProps.style),
          className: (0, _classnames["default"])(rest.className, iconWithTextProps.className),
          sx: _objectSpread({}, iconWithTextProps === null || iconWithTextProps === void 0 ? void 0 : iconWithTextProps.sx)
        }));
      }

      if (error || !data) {
        var _error$response, _error$response2, _error$response2$data;

        return (0, _core.jsx)(_Error["default"], (0, _extends2["default"])({
          code: (error === null || error === void 0 ? void 0 : error.code) || (error === null || error === void 0 ? void 0 : (_error$response = error.response) === null || _error$response === void 0 ? void 0 : _error$response.status),
          name: "Invalid ".concat(displayName).concat(id ? " ".concat(id) : ''),
          message: "".concat((error === null || error === void 0 ? void 0 : error.name) ? "".concat(error.name, ": ") : '').concat((error === null || error === void 0 ? void 0 : (_error$response2 = error.response) === null || _error$response2 === void 0 ? void 0 : (_error$response2$data = _error$response2.data) === null || _error$response2$data === void 0 ? void 0 : _error$response2$data.text) || (error === null || error === void 0 ? void 0 : error.message) || (!data ? 'No data' : 'Unknown error')).concat(id ? " for ".concat(displayName, " ").concat(id) : ''),
          disableTooltip: disableTooltip,
          disableIcon: disableIcon,
          disableText: disableText,
          inline: inline
        }, errorProps, {
          iconProps: _objectSpread({}, errorProps === null || errorProps === void 0 ? void 0 : errorProps.iconProps, {}, iconProps)
        }, {
          style: _objectSpread({}, rest.style, {}, errorProps === null || errorProps === void 0 ? void 0 : errorProps.style),
          className: (0, _classnames["default"])(rest.className, errorProps.className),
          sx: _objectSpread({}, rest.sx, {}, errorProps === null || errorProps === void 0 ? void 0 : errorProps.sx)
        }));
      }

      return (0, _core.jsx)(Component, (0, _extends2["default"])({}, rest, {
        ref: ref
      }));
    });
    WithLoading.propTypes = {
      id: _propTypes["default"].number,
      component: _propTypes["default"].elementType,
      data: _propTypes["default"].object,
      loading: _propTypes["default"].bool,
      error: _propTypes["default"].shape({
        code: _propTypes["default"].string,
        name: _propTypes["default"].string,
        message: _propTypes["default"].string
      }),
      disableIcon: _propTypes["default"].bool,
      disableText: _propTypes["default"].bool,
      disableTooltip: _propTypes["default"].bool,
      inline: _propTypes["default"].bool,
      iconWithTextProps: _propTypes["default"].object,
      errorProps: _propTypes["default"].object
    };
    WithLoading.defaultProps = {
      id: null,
      data: null,
      loading: false,
      error: null,
      component: defaultComponent,
      disableIcon: defaultDisableIcon,
      disableText: defaultDisableText,
      disableTooltip: defaultDisableTooltip,
      inline: defaultInline,
      iconWithTextProps: defaultIconWithTextProps,
      errorProps: defaultErrorProps
    };
    WithLoading.displayName = "WithLoading(".concat(displayName, ")");
    return WithLoading;
  };
};

exports["default"] = _default;
//# sourceMappingURL=withLoading.js.map